Changes between versions
************************

This document lists functionality differences between each major
version of Modules. The goal of each following section is to reference
the features of previous major version that are missing or behave
differently on the next major version and the features that can only
be found on this newer version. For instance the Modules 4 section
lists the changes compared to Modules 3.2.

Regarding deprecated or newly introduced features, this document only
lists their name or the command line argument related to them. Please
refer to the module and the modulefile man pages of the previous or
newer Modules version to learn the details about these removed or
added features.


Modules 4
=========

This section provides the list of differences with Modules version
3.2. This version of Modules is also referred in this document as
*compatibility version*. Modules 4 is based on what was previously
called Modules-Tcl. Comparison takes as a basis version "3.2.10" of
compatibility version against Modules version "4.0". Any change made
past these versions will explicitly mention the release number
starting from the difference appears or disappears.

Note:

  The numerous bugs or limitations spotted on Modules "3.2" across the
  years have been fixed in Modules "4.0". The list of reported issues
  that have been solved are available on the project code forge.


Removed or changed features
---------------------------

This section describes the features of the compatibility version that
are not supported or that behave differently on Modules 4.


Package Initialization
~~~~~~~~~~~~~~~~~~~~~~

"MODULESBEGINENV" environment snapshot functionality is not supported
on version 4. Modules collection mechanism should be preferred to save
and restore sets of enabled modulepaths and loaded modulefiles.
Modules 4 also introduces a system configuration file *init/modulerc*,
located in Modules installation directory. Starting version "4.3",
this file could also be *etc/initrc*. This *modulerc*/*initrc* file is
sourced by Modules shell initialization scripts and helps to setup the
initial environment right after initializing the **module** command.


Command line switches
~~~~~~~~~~~~~~~~~~~~~

**--human**

**--create**, **-c**

**--userlvl** lvl, **-u** lvl

   These command line switches are not supported on Modules 4. When
   these options are passed on the command-line, it produces an
   *Unsupported option* warning and command is ran with the
   unsupported switches ignored.

**--ter**

**--lon**

**--sil**

**--verb**

   These intermediate-form command line switches are not supported on
   Modules 4. Short or long switch name should be used instead.

"-h"

   This command line switch is short version of "--help" switch on
   Modules 4 whereas it is short version of **--human** switch on
   compatibility version.

"--force", "-f"

   This command line switch was not supported starting Modules version
   "4.0" but reintroduced starting version "4.2" with a different
   meaning: instead of enabling an active dependency resolution
   mechanism "--force" command line switch now enables to by-pass
   dependency consistency when loading or unloading a *modulefile*.

"--verbose", "-v"

"--silent", "-s"

   These command line switches were not supported starting Modules
   version "4.0" but reintroduced starting version "4.3". However,
   reintroduced "--silent" switch does not redirect stderr channel to
   "/dev/null" if stderr is found not to be a tty.

"--icase", "-i"

   This command line switch was not supported starting Modules version
   "4.0" but reintroduced starting version "4.4". When "--icase"
   switch is now set it applies to search query string and module
   specification on all sub-commands and modulefile Tcl commands.


Module Sub-Commands
~~~~~~~~~~~~~~~~~~~

On compatibility version, paths composing the "MODULEPATH" environment
variable may contain reference to environment variable. These variable
references are resolved dynamically when "MODULEPATH" is looked at
during module sub-command action like "avail". This feature was
missing on Modules "4.0" but it has been re-introduced on Modules
"4.1".

"update"

   This module sub-commands is not supported on Modules 4.

"clear"

   This command line switch was not supported starting Modules version
   "4.0" but reintroduced starting version "4.3". It now takes into
   account the "--force" command-line switch to skip confirmation
   dialog.

"refresh"

   On compatibility version, only the shell aliases defined by the
   currently loaded modulefiles are set again on a "refresh" command.
   Whereas on Modules 4 this command is an alias on the "reload"
   command that "unload" then "load" all the currently loaded
   modulefiles.

"help"

   Compatibility version redirects output made on stdout in
   "ModulesHelp" Tcl procedure to stderr.

   During an "help" sub-command, only the "ModulesHelp" Tcl procedure
   of a modulefile is interpreted on compatibility version. Version 4
   interprets all the content of the modulefile, then call the
   "ModulesHelp" procedure if it exists.

   On version 4, "ModulesHelp" subroutine is not ran if an error
   occurred during the interpretation of the *modulefile* main body.

"display"

   On version 4, "ModulesDisplay" subroutine is not ran if an error
   occurred during the interpretation of the *modulefile* main body.

"avail"

   On compatibility version, the same Tcl interpreter is used for the
   interpretation of all *.modulerc* or *.version* files during an
   "avail" command but the state of this interpreter is not reset
   between each interpretation. So some variable and procedure
   definitions may spread from one interpretation to another on this
   compatibility version. Modules 4 reuses the same interpreter for
   all *.modulerc* or *.version* interpretation but it is cleaned
   between each interpretation to protect from definition spread.

   In case of "--terse" or "--long" mode, all enabled modulepaths will
   be displayed whether they hold result to display or not. Modules 4
   outputs only the modulepaths where matching results are found.
   Modulepaths with no result to report are discarded from output.

"apropos"

   On Modules 4, *string* passed as argument is always searched in a
   case insensitive manner.

"load"

   On Modules 4, the value of an environment variable is set even if
   the new value is the same as the current value of this variable in
   environment.

   When an already loaded *modulefiles* is asked for load again,
   compatibility version will refresh the shell alias definition this
   modulefile hold if any, whereas Modules 4 will ignore the new load
   order.

   In case of *modulefile* loading another modulefile, if sub-
   modulefile load fails calling modulefile will still be loaded on
   compatibility version whereas Modules 4 will also abort calling
   modulefile load. Compatibility version behavior could be restored
   by enclosing "module load" command and arguments within "catch" Tcl
   command.

   Starting with version "4.1", content sent to the "stdout" channel
   during a *modulefile* interpretation is spooled to effectively
   transmit this content to stdout after rendering the environment
   changes made by this modulefile.

"unload"

   On Modules 4, the value of an environment variable is set even if
   the new value is the same as the current value of this variable in
   environment.

   Compatibility version enables to load a *modulefile* by passing on
   the command-line the name of a module alias or symbolic version
   pointing to this modulefile. However this module alias or symbolic
   version name cannot be used to unload the modulefile once loaded.
   Modules 4 enables to pass a module alias or symbolic version name
   to unload a loaded modulefile referred by this name.

   On versions "4.0" and "4.1", unloading an nonexistent modulefile
   generates an *Unable to locate modulefile* error. Starting with
   version "4.2", unloading a module only looks at loaded module list
   and does not trigger a modulefile search. So starting version "4.2"
   the same behavior than Modules compatibility version is obtained.

   Starting with version "4.1", content sent to the "stdout" channel
   during a *modulefile* interpretation is spooled to effectively
   transmit this content to stdout after rendering the environment
   changes made by this modulefile.

   When the specified module to unload matches multiple loaded
   modules, Modules 4 unloads lastly loaded module whereas
   compatibility version unloads firstly loaded module. A
   configuration option "unload_match_order" has been introduced in
   version "4.3" and it enables to restore the behavior of
   compatibility version when it is set to "returnfirst".

"switch"

   When switching on version 4 an *old* modulefile by a *new* one, no
   error is raised if *old* modulefile is not currently loaded. In
   this situation compatibility version throws an error and abort
   switch action.

   When switching on Modules 4 an *old* modulefile by a *new* one,
   this *new* modulefile does not keep the position that the *old*
   modulefile had in the "LOADEDMODULES" list as done on compatibility
   version but it is appended to the end of the list. Same goes for
   PATH-like environment variables: replaced PATH component is
   appended to the end or prepended to the beginning of the relative
   PATH-like variable, not appended or prepended relatively to the
   position hold by the swapped PATH component.

   When a modulefile loads another modulefile with a *module load*
   order, this sub-module is not unloaded when the top modulefile is
   swapped-out during a "switch" command on compatibility version.
   Version 4 interprets the swapped-out modulefile in unload mode, so
   the *module load* order is interpreted as *module unload* order and
   sub-module is unloaded.

"use"

   When the modulepath to enable is passed as a relative path,
   compatibility version will set it using passed relative name
   whereas Modules 4 will determine the corresponding absolute path
   and will register it rather passed relative name.

"unuse"

   Modules 4 provides path element counting feature which increases a
   reference counter each time a given path entry is added to a given
   environment variable. This feature also applies to the "MODULEPATH"
   environment variable. As consequence a modulepath entry element is
   removed from the modulepath enabled list only if the related
   element counter is equal to 1. When unusing a modulepath if its
   reference counter is greater than 1, modulepath is kept enabled and
   reference counter is decreased by 1.

"whatis"

   On Modules 4, environment variable edition commands (*setenv*,
   *unsetenv*, *append-path*, *prepend-path* and *remove-path*) do no
   set variable to the defined value on the modulefile evaluation
   context during a "whatis" evaluation. Instead environment variables
   are initialized with an empty value if undefined, to avoid raising
   error when attempting access to an undefined element during the
   modulefile evaluation.

"initadd"

"initprepend"

"initswitch"

   On version 4 no message is displayed to give details on how list of
   modulefiles to load has been altered in initialization file.

"initrm"

   No message is displayed on Modules 4 to inform of the modulefiles
   that have been removed from the loading list in initialization
   file.

   Empty "module load" line is left on version 4 when last modulefile
   from a line is asked to be removed. On compatibility version
   "module load null" line is set in this case.

"initclear"

   Empty "module load" lines are left on version 4 whereas "module
   load null" lines are set on compatibility version.


Modules Specific Tcl Commands
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

On version 4 the characters that have a special meaning when rendered
in shells are escaped when used in value to set environment variables,
shell alias or shell functions. Thus it is possible to set environment
elements with value containing these special characters (like
backticks). On version 3 these special characters were evaluated by
shell when recording the environment changes implied by modulefile
evaluation.

"append-path"

"prepend-path"

   Modules 4 produces an error when adding a bare colon character *:*
   as a path element to a path-like variable, as this colon cannot be
   distinguished from the colon used for path separator.

   Modules 4 supports adding or removing empty path element to a path-
   like variable, whereas compatibility version looses track of this
   path element when the path-like variable is modified afterward.
   Empty path element enables to set a leading colon character *:*,
   which has a specific meaning on some regular environment variable
   like "MANPATH" or "LD_LIBRARY_PATH".

   When adding a path element to the "MANPATH" environment variable,
   Modules 4 is treating this variable like any other whereas a
   special treatment was applied on compatibility version: a default
   MANPATH value, set at configure time, was appended in case
   "MANPATH" variable was unset.

"remove-path"

   Modules 4 provides path element counting feature which increases a
   reference counter each time a given path entry is added to a given
   environment variable. As consequence a path entry element is
   removed from a path-like variable only if the related element
   counter is equal to 1. If this counter is greater than 1, path
   element is kept in variable and reference counter is decreased by
   1.

   When unloading a modulefile, "remove-path" command is not applied
   to environment variable on Modules 4, whereas on compatibility
   version it is processed the exact same way than when loading
   modulefile.

"exit"

   On Modules 4 code passed to the "exit" Modules specific Tcl command
   will not be thrown to be the **module** return value.

"module-alias"

"module-version"

   In case the specified aliased module or the symbolic version
   introduces a resolution loop with already defined aliases or
   symbolic versions, this new alias or symbolic version is not
   registered and an error message is raised. On compatibility
   version, alias or symbolic version introducing loop are registered
   as the modulefile resolution is not computed at registration time.

"module-info"

   **module-info flags**

   **module-info trace**

   **module-info tracepat**

   **module-info user**

      These "module-info" options are related to compatibility
      version-specific features so they are available on Modules 4 but
      with a dummy implementation that always returns false or an
      empty value.

   **module-info mode**

      During an "unload" sub-command, "unload" is returned instead of
      "remove". However if *mode* is tested against "remove" value,
      true will be returned.

      During a "switch" sub-command, "unload" then "load" is returned
      instead of "switch1" then "switch2" then "switch3". However if
      *mode* is tested against "switch" value, true will be returned.

   **module-info name**

      If the module name passed to the command-line has been specified
      as a full path name, the **module-info name** used in modulefile
      returns this file base name on compatibility version whereas it
      returns on Modules 4+ the full path name as it is identified by
      this name once loaded.

   **module-info version**

      Declared aliases or symbolic versions are not registered anymore
      if they introduce a resolution loop. As a result **module-info
      version** does not return an "*undef*" string value as it does
      not face resolution loop situation anymore.

   **module-info symbols**

      Declared aliases or symbolic versions are not registered anymore
      if they introduce a resolution loop. As a consequence symbolic
      versions introducing loop situation are not part anymore of the
      **module-info symbols** returned result as they are not
      registered.

      A symbolic version sets on a module alias will be propagated
      toward the resolution path to also apply to the relative
      *modulefile* if it still correspond to the same module name.

"module-log"

"module-trace"

"module-user"

"module-verbosity"

   These Modules specific Tcl commands are related to compatibility
   version-specific features so they are available on Modules 4 but
   with a dummy implementation that always displays a warning message
   saying the command is not implemented.

"module-whatis"

   When multiple words are passed as argument to "module-whatis" but
   they are not enclosed in double-quotes or curly braces they will be
   displayed as a single line on Modules 4 whereas compatibility
   version displays them as one line per word.

"set-alias"

   Whereas compatibility version sets a shell function when variables
   are in use in alias value on Bourne shell derivatives, Modules 4
   always defines a shell alias never a shell function.

"setenv"

   On compatibility version the "setenv" modulefile command accepts
   any number of argument, but ignores all arguments after the first
   two. An error is raised on Modules 4 when more than two arguments
   are passed to the "setenv" modulefile command.


Locating Modulefiles
~~~~~~~~~~~~~~~~~~~~

On version 4, when a module alias is set and overrides name of an
existing directory, this alias is taken into account to locate the
default version of this module name and the *modulefiles* locating in
the directory are ignored.

When looking for an implicit default in a *modulefile* directory,
aliases are taken into account in addition to *modulefiles* and
directories to determine the highest numerically sorted element.

Modules 4 will resolve module alias or symbolic version passed to
"unload" command to then remove the loaded modulefile pointed by the
mentioned alias or symbolic version.

Modules 4 resolves module alias or symbolic version pointing to a
*modulefile* located in another modulepath.

When locating *modulefiles* on Modules 4, if a *.modulerc*, a
*.version*, a directory or a *modulefile* cannot be read during the
search it is simply ignored with no error message produced. Visibility
of *modulefiles* can thus be adapted to the rights the user has been
granted. Exception is made when trying to directly access a directory
or a *modulefile*. In this case, the access issue is returned as an
error message. Access issue is also returned when a direct access is
made to a module alias or a symbolic version targeting an unreadable
*modulefile*.


New features
------------

This section describes the features of Modules version 4 that are not
supported on the compatibility version. Please refer to the above
section for features supported by both versions but behaving
differently.


Package Initialization
~~~~~~~~~~~~~~~~~~~~~~

Support for *fish*, *lisp*, *tcl* and *R* code output has been
introduced on Modules "4.0".

On version 4 and for *sh*, *bash*, *ksh*, *zsh* and *fish* shells,
text output, like listing from the "avail" command, is redirected from
*stderr* to *stdout* after shell command evaluation if shell is in
interactive mode. Starting version "4.1", this content redirection
occurs if shell session is attached to a terminal.

Starting version "4.5", a new alias or function called **ml** may be
defined at initialization time, to provide a handy frontend to the
**module** command.

Starting version "4.5", support for Windows *cmd* shell is introduced.


Modulecmd startup
~~~~~~~~~~~~~~~~~

Starting with version "4.1", "modulecmd.tcl" sources upon invocation a
site-specific configuration script named "siteconfig.tcl". This Tcl
script enables to supersede any global variable or procedure
definition of modulecmd.tcl.


Command line switches
~~~~~~~~~~~~~~~~~~~~~

The following command line switches appeared on Modules 4.

+--------------+-------------------------------------------------------------------+
| Introduced   | New command line switches                                         |
| in version   |                                                                   |
|==============|===================================================================|
| 4.0          | "--debug", "-D", "--default", "-d", "--latest", "-L"              |
+--------------+-------------------------------------------------------------------+
| 4.1          | "--paginate", "--no-pager"                                        |
+--------------+-------------------------------------------------------------------+
| 4.2          | "--auto", "--no-auto"                                             |
+--------------+-------------------------------------------------------------------+
| 4.3          | "--indepth", "--no-indepth", "--color", "--starts-with", "-S",    |
|              | "-- contains", "-C"                                               |
+--------------+-------------------------------------------------------------------+
| 4.5          | "--json", "-j"                                                    |
+--------------+-------------------------------------------------------------------+
| 4.6          | "--trace", "-T", "--all", "-a", "-DD"                             |
+--------------+-------------------------------------------------------------------+
| 4.7          | "-vv", "--output", "-o", "--width", "-w"                          |
+--------------+-------------------------------------------------------------------+


Module Sub-Commands
~~~~~~~~~~~~~~~~~~~

The following module sub-commands appeared on Modules 4.

+--------------+-------------------------------------------------------------------+
| Introduced   | New module sub-commands                                           |
| in version   |                                                                   |
|==============|===================================================================|
| 4.0          | "reload", "source", "search", "save", "restore", "saverm",        |
|              | "saveshow", "savelist", "path", "paths", "autoinit", "aliases",   |
|              | "test"                                                            |
+--------------+-------------------------------------------------------------------+
| 4.1          | "append-path", "prepend-path", "remove-path", "is-loaded", "is-   |
|              | saved" "is-used", "is-avail", "info-loaded"                       |
+--------------+-------------------------------------------------------------------+
| 4.3          | "config"                                                          |
+--------------+-------------------------------------------------------------------+
| 4.6          | "sh-to-mod"                                                       |
+--------------+-------------------------------------------------------------------+
| 4.8          | "edit", "try-load"                                                |
+--------------+-------------------------------------------------------------------+

All module sub-commands will return a non-zero exit code in case of
error whereas on compatibility version issues that occurred do not
lead to an exit of the **module** command with a non-zero code.

Starting with version "4.1", **module** function for all scripting
languages, like Perl or Python, always returns a value. In case of
error, a *false* boolean value is returned instead of raising a fatal
exception. For module sub-commands returning a text value, the module
function will actually return this value. In all other cases a *true*
boolean value is returned.

"avail", "whatis" and "apropos"

   Non-critical errors are not displayed on "avail", "whatis" and
   "apropos" sub-commands. Only valid results are returned.

   Module aliases are included in the result of these sub-commands.
   They are displayed in the module path section where they are
   defined or in a *global/user modulerc* section for aliases set in
   user's or global modulerc file. A "@" symbol is added in
   parenthesis next to their name to distinguish them from
   *modulefiles*.

   Search may be performed with an alias or a symbolic version-name
   passed as argument.

   Arguments to these "avail", "whatis" and "apropos" commands may use
   wildcard characters to express glob patterns.


Collections
~~~~~~~~~~~

Modules Collections have been introduced on Modules "4.0".


Environment
~~~~~~~~~~~

The following environment variables appeared on Modules 4.

+--------------+-------------------------------------------------------------------+
| Introduced   | New environment variables                                         |
| in version   |                                                                   |
|==============|===================================================================|
| 4.0          | "MODULECONTACT", "MODULES_COLLECTION_TARGET",                     |
|              | "MODULES_USE_COMPAT_VERSION", "<VAR>_modshare"                    |
+--------------+-------------------------------------------------------------------+
| 4.1          | "MODULES_CMD", "MODULES_COLLECTION_PIN_VERSION", "MODULES_PAGER", |
|              | "MODULES_RUNENV_<VAR>", "MODULES_RUN_QUARANTINE",                 |
|              | "MODULES_SILENT_SHELL_DEBUG", "<VAR>_modquar"                     |
+--------------+-------------------------------------------------------------------+
| 4.2          | "MODULES_AUTO_HANDLING", "MODULES_LMALTNAME",                     |
|              | "MODULES_LMCONFLICT", "MODULES_LMNOTUASKED", "MODULES_LMPREREQ"   |
+--------------+-------------------------------------------------------------------+
| 4.3          | "MODULES_AVAIL_INDEPTH", "MODULES_COLOR", "MODULES_COLORS",       |
|              | "MODULES_IMPLICIT_DEFAULT", "MODULES_SEARCH_MATCH",               |
|              | "MODULES_SET_SHELL_STARTUP", "MODULES_SITECONFIG",                |
|              | "MODULES_TERM_BACKGROUND", "MODULES_UNLOAD_MATCH_ORDER",          |
|              | "MODULES_VERBOSITY", "MODULES_WA_277"                             |
+--------------+-------------------------------------------------------------------+
| 4.4          | "MODULES_ADVANCED_VERSION_SPEC", "MODULES_EXTENDED_DEFAULT",      |
|              | "MODULES_ICASE"                                                   |
+--------------+-------------------------------------------------------------------+
| 4.5          | "MODULES_ML"                                                      |
+--------------+-------------------------------------------------------------------+
| 4.6          | "MODULES_LMSOURCESH", "MODULES_NEARLY_FORBIDDEN_DAYS"             |
+--------------+-------------------------------------------------------------------+
| 4.7          | "MODULES_SHELLS_WITH_KSH_FPATH", "MODULES_IMPLICIT_REQUIREMENT",  |
|              | "MODULES_LMTAG", "MODULES_TAG_ABBREV", "MODULES_TAG_COLOR_NAME",  |
|              | "MODULES_MCOOKIE_VERSION_CHECK" "MODULES_AVAIL_OUTPUT",           |
|              | "MODULES_AVAIL_TERSE_OUTPUT", "MODULES_LIST_OUTPUT",              |
|              | "MODULES_LIST_TERSE_OUTPUT", "MODULES_TERM_WIDTH"                 |
+--------------+-------------------------------------------------------------------+
| 4.8          | "MODULES_EDITOR", "MODULES_VARIANT_SHORTCUT", "MODULES_LMVARIANT" |
+--------------+-------------------------------------------------------------------+


Modules Specific Tcl Commands
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

The following modulefile Tcl commands appeared on Modules 4.

+--------------+-------------------------------------------------------------------+
| Introduced   | New modulefile Tcl commands                                       |
| in version   |                                                                   |
|==============|===================================================================|
| 4.0          | "module-info command", "getenv", "reportError", "reportWarning"   |
+--------------+-------------------------------------------------------------------+
| 4.1          | "module-info loaded", "is-saved", "is-used", "is-avail", "module- |
|              | virtual"                                                          |
+--------------+-------------------------------------------------------------------+
| 4.2          | "set-function", "unset-function"                                  |
+--------------+-------------------------------------------------------------------+
| 4.6          | "source-sh", "module-hide", "module-forbid", "module-info         |
|              | usergroups", "module-info username"                               |
+--------------+-------------------------------------------------------------------+
| 4.7          | "versioncmp", "module-tag", "module-info tags"                    |
+--------------+-------------------------------------------------------------------+
| 4.8          | "variant", "getvariant"                                           |
+--------------+-------------------------------------------------------------------+

"conflict" and "prereq"

   Starting with version "4.2", these Modules-specific Tcl commands
   support being called with a symbolic modulefile or a modulefile
   alias passed as argument.

"getenv"

   Starting with version "4.2", an optional *value* argument is added
   on "getenv" to define the value to return in case environment
   variable is not set.

"module"

   In case of "module load" command specifying multiple *modulefiles*,
   when mode is set to "unload" these *modulefiles* will be unloaded
   in the reverse order to ensure correct handling of prerequisites.

   Starting with version "4.7", the "load", "unload" and "switch" sub-
   commands support the "--not-req" option to avoid recording a prereq
   or a conflict requirement toward specified modules.

"append-path" and "prepend-path"

   Starting with version "4.1", both commands handle being called with
   multiple *value* arguments and option "--duplicates" is added.

"remove-path"

   Starting with version "4.1", "remove-path" handles being called
   with multiple *value* arguments and option "--index" is added.

"is-loaded"

   Starting with version "4.1", "is-loaded" supports being called with
   no argument passed. In this case, it returns *true* if any
   modulefile is currently loaded, *false* otherwise.

   Starting with version "4.2", "is-loaded" supports being called with
   a symbolic modulefile or a modulefile alias passed as argument.

   This Modules-specific Tcl command was not enabled for *modulerc*
   evaluation starting Modules version "4.0" but it has been
   reintroduced starting version "4.2.1".


Modules Variables
~~~~~~~~~~~~~~~~~

The following Modules-specific Tcl variables appeared on Modules 4.

+--------------+-------------------------------------------------------------------+
| Introduced   | New Modules-specific Tcl variables                                |
| in version   |                                                                   |
|==============|===================================================================|
| 4.7          | "ModuleTool", "ModuleToolVersion"                                 |
+--------------+-------------------------------------------------------------------+
| 4.8          | "ModuleVariant"                                                   |
+--------------+-------------------------------------------------------------------+


Modules configuration options
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

The concept of configuration option has been introduced on Modules
"4.3". The following Modules configuration option has been introduced
on Modules 4.

+--------------+-------------------------------------------------------------------+
| Introduced   | New Modules configuration options                                 |
| in version   |                                                                   |
|==============|===================================================================|
| 4.3          | "auto_handling", "avail_indepth", "collection_pin_version",       |
|              | "collection_target", "color", "colors", "contact",                |
|              | "extra_siteconfig", "implicit_default", "locked_configs",         |
|              | "pager", "rcfile", "run_quarantine", "silent_shell_debug",        |
|              | "search_match", "set_shell_startup", "term_background",           |
|              | "unload_match_order", "verbosity", "wa_277"                       |
+--------------+-------------------------------------------------------------------+
| 4.4          | "advanced_version_spec", "extended_default", "home", "icase"      |
+--------------+-------------------------------------------------------------------+
| 4.5          | "ml"                                                              |
+--------------+-------------------------------------------------------------------+
| 4.6          | "nearly_forbidden_days"                                           |
+--------------+-------------------------------------------------------------------+
| 4.7          | "avail_output", "avail_terse_output", "implicit_requirement",     |
|              | "list_output", "list_terse_output", "mcookie_version_check",      |
|              | "shells_with_ksh_fpath", "tag_abbrev", "tag_color_name",          |
|              | "term_width"                                                      |
+--------------+-------------------------------------------------------------------+
| 4.8          | "editor", "variant_shortcut"                                      |
+--------------+-------------------------------------------------------------------+

"list_output", "list_terse_output"

   Starting version 4.8, element "variant" is added to the list of
   accepted values. It is added to the default value list of
   "list_output".


Modules 5
=========

This section provides the list of differences with Modules version 4.
Comparison takes as a basis version "4.8" against Modules version
"5.0". Any change made past these versions will explicitly mention the
release number starting from the difference appears or disappears.


Removed or changed features
---------------------------

This section describes the features of Modules 4 that are not
supported or that behave differently on Modules 5.


Package Initialization
~~~~~~~~~~~~~~~~~~~~~~

The initialization configuration file "initrc" and the modulepath-
specific configuration file "modulespath" are now searched by default
in the "etcdir" instead of in the "initdir". Moreover these
configuration files are only searched in one location. Previously they
were searched in both "etcdir" and "initdir" locations by Modules
initialization process.

When initializing Modules, the "initrc" configuration file is
evaluated in addition to the the "modulespath" configuration file and
not instead of this file. "initrc" is evaluated after "modulespath"
file.

Report the modules loading and unloading during the evaluation of the
"initrc" configuration file. These report messages are disabled when
the "verbosity" configuration option is set to "concise" or "silent".

Enforce use of the Modules magic cookie (i.e., "#%Module" file
signature) at the start of "initrc" configuration file. No evaluation
occurs and an error is produced if the magic cookie is missing or if
the optional version number placed after the cookie string is higher
than the version of the "modulecmd.tcl" script in use.

Quarantine mechanism code in the Modules shell initialization scripts
is now always defined and mechanism always applies if some environment
variables are defined in "MODULES_RUN_QUARANTINE". Code in the
"modulecmd.tcl" script to restore environment variables put in
quarantine is now always generated and applies if the
"__MODULES_QUARANTINE_SET" environment variable is set to "1". By
default on Modules 5 the **module** shell function definition is
generated without quarantine support but it could be enabled by
setting "quarantine_support" to "1" in "initrc".

Code to silence shell debug properties in the Modules shell
initialization scripts is now always defined and mechanism applies if
"MODULES_SILENT_SHELL_DEBUG" is set to "1". Code to silence shell
debug properties in the **module** shell function could now be enabled
if "MODULES_SILENT_SHELL_DEBUG" is set to "1" prior Modules
initialization or if the "silent_shell_debug" configuration option is
set to "1" in the "initrc" configuration file. Option is set off by
default on Modules 5.

During the "autoinit" process, the environment variable
"__MODULES_AUTOINIT_INPROGRESS" is checked and if it is found set to
"1", the initialization process immediately ends. If not, this
environment variable is set to "1" which ensures no initialization
loop could occur, especially when the "set_shell_startup"
configuration option is set.


Modulecmd startup
~~~~~~~~~~~~~~~~~

Enforce use of the Modules magic cookie (i.e., "#%Module" file
signature) at the start of global or user rc files. These files are
not evaluated and an error is produced if the magic cookie is missing
or if the optional version number placed after the cookie string is
higher than the version of the "modulecmd.tcl" script in use.


Module Sub-Commands
~~~~~~~~~~~~~~~~~~~

"append-path", "prepend-path", "remove-path"

   When sub-command is not called during a modulefile evaluation, the
   reference counter associated with each entry in targeted
   environment variable is ignored. In such context, a "module append-
   path/prepend-path" will not increase the reference counter of a
   path entry already defined and a "module remove-path" will remove
   specified path whatever its reference counter value.

"display"

   No error is raised when evaluating a modulefile without a value
   specified for the "variant" it defines. As a result, the
   unspecified variant is not instantiated in the "ModuleVariant"
   array variable.

"load"

   Reference counting mechanism is not anymore applied to the Modules-
   specific path variables (like "LOADEDMODULES"). As a result no
   "__MODULES_SHARE_<VAR>" variable is set in user environment for
   these variables. Exception is made for "MODULEPATH" environment
   variable where the mechanism still applies.

"refresh"

   Sub-command evaluates all loaded modulefiles and re-apply the non-
   persistent environment changes they define (i.e., shell aliases,
   shell functions and command put on stdout channel). With this
   change the "refresh" sub-command is restored to the behavior it had
   on Modules version 3.2.

"restore", "source"

   Only report the module load and unload directly triggered by these
   sub-commands. Load and unload triggered by other modules are
   reported through the automated module handling messages of the main
   modules.

"restore"

   Starting Modules 5.2:

   * if no argument is provided and if default collection does not
     exist, initial environment is restored.

   * *sticky* modules are unloaded when restoring a collection.

"source"

   Enforce use of the Modules magic cookie (i.e., "#%Module" file
   signature) at the start of any scriptfile passed for evaluation to
   the "source" sub-command. These files are not evaluated and an
   error is produced if the magic cookie is missing or if the optional
   version number placed after the cookie string is higher than the
   version of the "modulecmd.tcl" script in use.

"saveshow"

   Starting Modules 5.2, if no argument is provided and if default
   collection does not exist, initial environment is displayed.

"use"

   Non-existent modulepath is now accepted as argument.

   Reference counting mechanism is ignored when sub-command is not
   called during a modulefile evaluation. In such context, a "module
   use" will not increase the reference counter of a path entry
   already defined.

"unuse"

   Reference counting mechanism is ignored when sub-command is not
   called during a modulefile evaluation. In such context, a "module
   unuse" will remove specified path whatever its reference counter
   value.

   Correctly handle several modulepaths specified as a single argument
   (i.e., "/path/to/dir1:/path/to/dir2").


Modules Specific Tcl Commands
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

"append-path", "prepend-path"

   When an element is added to a path-like variable, add this element
   to the associated reference counter variable (named
   "__MODULES_SHARE_<VAR>") only when this element is added multiple
   times to the path-like variable. When an element is removed from a
   path-like variable, this element is removed from the reference
   counter variable when its counter is equal to 1.

"chdir", "module", "module-trace", "module-verbosity", "module-user",
"module-log"

   These modulefile commands have been undeclared from the modulerc
   Tcl interpreter on Modules 5. An error message is obtained if still
   used instead of silently ignoring it.

"getenv"

   When passed environment variable is not defined, an empty string is
   returned by default rather "_UNDEFINED_".

"module"

   Forbid use of "module source" command in modulefile or in an
   initialization rc file, the "source" Tcl command should be used
   instead.

   Starting version "5.1" an error is raised when an unused option is
   set on "module use" or "module unuse" commands.

"unsetenv"

   When running on an unload evaluation, do not unset designated
   environment variable if no value to restore is provided.

   Distinguish between being called on a unload evaluation without a
   value to restore or with an empty string value to restore.

"variant"

   Starting version 5.1, "variant" command accepts being called
   without a list of accepted value defined. In this case, any value
   specified is accepted.

   Starting version 5.5, a valid variant name is only composed of the
   "[A-Za-z0-9_-]"  characters. It cannot start with "-" character and
   the name as a whole cannot correspond to a number.


Locating Modulefiles
~~~~~~~~~~~~~~~~~~~~

As the Advanced module version specifiers mechanism is enabled by
default on Modules 5.0, several characters are made special and cannot
be used anymore in module name or version. These characters are "@",
"=", "~", "+" and ",". Also a module name cannot start with "-"
character. Module name is allowed to finish by one or more "+"
character but "+" cannot be used at the start or inside a module name.

Starting version 5.5, characters "+" and "~" may be part of module
name or version as long as the string part next to these character is
not a valid variant name.


Environment
~~~~~~~~~~~

The following Modules environment variables have been changed on
Modules 5.

+----------------------------------------+-----------------------------------------------+
| Environment variable                   | Change                                        |
|========================================|===============================================|
| "MODULES_LMALTNAME"                    | Renamed to "__MODULES_LMALTNAME"              |
+----------------------------------------+-----------------------------------------------+
| "MODULES_LMCONFLICT"                   | Renamed to "__MODULES_LMCONFLICT"             |
+----------------------------------------+-----------------------------------------------+
| "MODULES_LMNOTUASKED"                  | Removed                                       |
+----------------------------------------+-----------------------------------------------+
| "MODULES_LMPREREQ"                     | Renamed to "__MODULES_LMPREREQ"               |
+----------------------------------------+-----------------------------------------------+
| "MODULES_LMSOURCESH"                   | Renamed to "__MODULES_LMSOURCESH"             |
+----------------------------------------+-----------------------------------------------+
| "MODULES_LMTAG"                        | Renamed to "__MODULES_LMTAG"                  |
+----------------------------------------+-----------------------------------------------+
| "MODULES_LMVARIANT"                    | Renamed to "__MODULES_LMVARIANT"              |
+----------------------------------------+-----------------------------------------------+
| "MODULES_USE_COMPAT_VERSION"           | Removed                                       |
+----------------------------------------+-----------------------------------------------+
| "<VAR>_modquar"                        | Renamed to "__MODULES_QUAR_<VAR>"             |
+----------------------------------------+-----------------------------------------------+
| "<VAR>_modshare"                       | Renamed to "__MODULES_SHARE_<VAR>"            |
+----------------------------------------+-----------------------------------------------+


Modules configuration options
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

The default value of the following Modules configuration option has
been changed on Modules 5.

+-----------------------------------+--------------------------+---------------------+
| Configuration option              | Previous default value   | New default value   |
|===================================|==========================|=====================|
| "auto_handling"                   | "0"                      | "1"                 |
+-----------------------------------+--------------------------+---------------------+
| "extended_default"                | "0"                      | "1"                 |
+-----------------------------------+--------------------------+---------------------+
| "advanced_version_spec"           | "0"                      | "1"                 |
+-----------------------------------+--------------------------+---------------------+
| "color"                           | "never"                  | "auto"              |
+-----------------------------------+--------------------------+---------------------+
| "icase"                           | "never"                  | "search"            |
+-----------------------------------+--------------------------+---------------------+
| "set_shell_startup"               | "1"                      | "0"                 |
+-----------------------------------+--------------------------+---------------------+
| "silent_shell_debug"              | *undefined*              | "0"                 |
+-----------------------------------+--------------------------+---------------------+


New features
------------


Package Initialization
~~~~~~~~~~~~~~~~~~~~~~

When initializing Modules, "refresh" the loaded modules in case some
user environment is already configured.

Starting version "5.5", support for Windows *pwsh* shell is
introduced.


Command line switches
~~~~~~~~~~~~~~~~~~~~~

The following command line switches appeared on Modules 5.

+--------------+-------------------------------------------------------------------+
| Introduced   | New command line switches                                         |
| in version   |                                                                   |
|==============|===================================================================|
| 5.1          | "--redirect", "--no-redirect", "--tag"                            |
+--------------+-------------------------------------------------------------------+
| 5.2          | "--timer"                                                         |
+--------------+-------------------------------------------------------------------+
| 5.3          | "--ignore-cache", "--ignore-user-rc"                              |
+--------------+-------------------------------------------------------------------+

"--output"

   Starting Modules 5.3, this command line switch accepts value
   prefixed by "+" or "-" which means value should respectively be
   appended to or subtracted from current configuration option value.

"--force"

   Starting Modules 5.4, this command line switch by-passes *abort on
   error* behavior. Modulefile is unloaded anyway when an evaluation
   error occurs if "--force" option is used.


Module Sub-Commands
~~~~~~~~~~~~~~~~~~~

The following module sub-commands appeared on Modules 5.

+--------------+-------------------------------------------------------------------+
| Introduced   | New module sub-commands                                           |
| in version   |                                                                   |
|==============|===================================================================|
| 5.1          | "state", "load-any"                                               |
+--------------+-------------------------------------------------------------------+
| 5.2          | "lint", "mod-to-sh", "reset", "stash", "stashpop", "stashrm",     |
|              | "stashshow", "stashclear", "stashlist"                            |
+--------------+-------------------------------------------------------------------+
| 5.3          | "cachebuild", "cacheclear"                                        |
+--------------+-------------------------------------------------------------------+

"list"

   Starting Modules 5.1:

   * this sub-command accepts patterns to filter the loaded modules to
     list.

   * the "--starts-with" and "--contains" options are supported on
     this sub-command to provide the regular search match
     capabilities.

   Starting Modules 5.3:

   * Search query with just a variant set (no module name and version)
     is accepted.

"refresh"

   Starting Modules 5.2, only the loaded modules listed in the
   "__MODULES_LMREFRESH" environment variables are refreshed.

"restore"

   Starting Modules 5.2, initial environment is restored when
   specified collection name is "__init__".

"savelist"

   Starting Modules 5.2:

   * this sub-command accepts patterns to filter the named collections
     to list.

   * the "--starts-with" and "--contains" options are supported on
     this sub-command to provide the regular search match
     capabilities.

   * the "--all" option is supported on this sub-command not to limit
     to the collection matching currently set collection target.

"saveshow"

   Starting Modules 5.2, initial environment is displayed when
   specified collection name is "__init__".

"sh-to-mod"

   Starting Modules "5.1", this sub-command also tracks shell
   completion changes for bash, tcsh and fish shells.

   Shell mode "bash-eval" is introduced on Modules version "5.4".

"source"

   Starting Modules 5.2, this sub-command accepts modulefile
   specification as argument in addition to file path.

"avail", "paths", "whatis"

   Starting Modules 5.3:

   * variant specified in search query is taken into account to return
     available modules matching the variant specification.

   * when one variant is specified multiple times in search query,
     returned modules are those providing all the specified variant
     values.

   * Search query with just a variant set (no module name and version)
     is accepted.

   * Extra specifier is accepted in search query to query content of
     modulefiles.

   Starting Modules 5.4:

   * "tag" Extra specifier is introduced.

   * set multiple values on extra specifier, each of them separated by
     comma character, to get modules matching any of these values
     (*OR* operator).

   * set multiple values on variant specification, each of them
     separated by comma character, to get modules providing any of
     these variant values (*OR* operator).

   Starting Modules 5.5:

   * "not:" prefix may be added to extra specifier criterion to select
     modules not matching specified values.

   * "not:" prefix may be added to variant specification to get
     modules not providing variant or not matching specified variant
     values.

"reload"

   Starting Modules 5.4, support for "--force" option is added on this
   sub-command.

"autoinit"

   Starting Modules 5.5, definition of **mogui** shell alias or
   function is added on this sub-command.


Environment
~~~~~~~~~~~

The following environment variables appeared on Modules 5.

+--------------+-------------------------------------------------------------------+
| Introduced   | New environment variables                                         |
| in version   |                                                                   |
|==============|===================================================================|
| 5.0          | "MODULES_QUARANTINE_SUPPORT", "__MODULES_QUARANTINE_SET",         |
|              | "__MODULES_AUTOINIT_INPROGRESS"                                   |
+--------------+-------------------------------------------------------------------+
| 5.1          | "MODULES_REDIRECT_OUTPUT", "MODULES_MCOOKIE_CHECK",               |
|              | "MODULES_FAMILY_<NAME>", "__MODULES_PUSHENV_<VAR>",               |
|              | "__MODULES_LMEXTRATAG", "MODULES_COLLECTION_PIN_TAG"              |
+--------------+-------------------------------------------------------------------+
| 5.2          | "MODULES_PROTECTED_ENVVARS", "MODULES_TCL_LINTER",                |
|              | "__MODULES_LMINIT", "MODULES_RESET_TARGET_STATE",                 |
|              | "__MODULES_LMREFRESH"                                             |
+--------------+-------------------------------------------------------------------+
| 5.3          | "MODULES_IGNORE_CACHE", "MODULES_CACHE_BUFFER_BYTES",             |
|              | "MODULES_CACHE_EXPIRY_SECS" "MODULES_IGNORE_USER_RC"              |
+--------------+-------------------------------------------------------------------+
| 5.4          | "MODULES_STICKY_PURGE", "MODULES_UNIQUE_NAME_LOADED",             |
|              | "MODULES_ABORT_ON_ERROR", "__MODULES_LMSTICKYRULE",               |
|              | "MODULES_SOURCE_CACHE"                                            |
+--------------+-------------------------------------------------------------------+
| 5.5          | "MODULES_HIDE_AUTO_LOADED", "MODULES_LOGGER",                     |
|              | "MODULES_LOGGED_EVENTS", "MODULES_CONFLICT_UNLOAD",               |
|              | "__MODULES_LMPREREQPATH"                                          |
+--------------+-------------------------------------------------------------------+


Modules Specific Tcl Commands
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

The following modulefile Tcl commands appeared on Modules 5.

+--------------+-------------------------------------------------------------------+
| Introduced   | New modulefile Tcl commands                                       |
| in version   |                                                                   |
|==============|===================================================================|
| 5.1          | "add-property", "remove-property", "extensions", "prereq-any",    |
|              | "require-fullname", "depends-on", "prereq-all", "always-load",    |
|              | "module load-any", "family", "complete", "uncomplete", "pushenv"  |
+--------------+-------------------------------------------------------------------+
| 5.4          | "modulepath-label"                                                |
+--------------+-------------------------------------------------------------------+
| 5.5          | "hide-modulefile", "hide-version", "lsb-release"                  |
+--------------+-------------------------------------------------------------------+

"system", "is-used"

   Starting Modules 5.0, these modulefile commands are available from
   a modulerc evaluation context.

"getenv"

   Starting version 5.1, the "--return-value" option is added to
   return environment variable value or its fallback when modulefile
   is evaluated in *display* mode.

"prereq", "module load/try-load/load-any/switch"

   Starting Modules 5.1, these modulefile commands accept the "--tag"
   option.

"prereq", "prereq-all", "always-load", "depends-on"

   Starting Modules 5.2, these modulefile commands accept the "--
   optional" option.

   Starting Modules 5.5, these modulefile commands accept the "--
   modulepath" option.

"module try-load/load-any"

   Starting Modules 5.1, these modulefile commands accept the "--not-
   req" option.

"module unload"

   Starting version "5.5" all matching modules loaded and their
   dependent are unloaded if both "auto_handling" and
   "conflict_unload" configuration options are enabled.

"module unuse"

   Starting version "5.1" options "--*-on-unload" added to the
   "remove-path" command are also added to the "module unuse" command.

"puts"

   Starting Modules 5.1, if content is sent to the "prestdout"
   channel, it is rendered as command to evaluate in current shell
   session and prior any other environment changes.

   Starting Modules 5.5, if content is sent to the "log" channel, it
   is sent to the defined "logger" command.

"remove-path"

   Starting with version "5.1":

   * the "--remove-on-unload" option is added to also remove value
     when modulefile is unloaded.

   * the "--append-on-unload" and "--prepend-on-unload" options are
     added to restore when modulefile is unloaded the value list unset
     at load time.

   * the "--noop-on-unload" option is added to perform no operation
     when modulefile is unloaded.

   Starting with version "5.4", the "--glob" option is added to remove
   value matching a glob-style pattern.

"setenv"

   Starting with version "5.1", the "--set-if-undef" option is added
   to set environment variable when modulefile is loaded only if not
   yet defined.

"source-sh"

   Starting Modules "5.1", this modulefile command also tracks shell
   completion changes for bash, tcsh and fish shells.

   Shell mode "bash-eval" is introduced on Modules version "5.4".

   "--ignore" option is introduced on Modules version "5.4".

"unsetenv"

   Starting with version "5.1":

   * the "--noop-on-unload" option is added to perform no operation
     when modulefile is unloaded.

   * the "--unset-on-unload" option is added to also unset variable
     when modulefile is unloaded.

"getvariant"

   Starting version 5.1, the "--return-value" option is added to
   return variant value or its fallback when modulefile is evaluated
   in *display* mode.

"module-tag", "module-hide", "module-forbid"

   Starting with version 5.4:

   * module can be specified with its full path file name to precisely
     target one modulefile.

   * module specification on which stickiness applies is recorded in
     loaded environment to determine if it is still satisfied when
     updating environment.

   * options "--user" and "--group" are added.

"break"

   Starting with version 5.4, a modulefile using "break" may be
   unloaded anyway if forced. To forbid unload of a modulefile, it is
   now advised to tag it "super-sticky" with "module-tag" command.

"conflict", "family"

   Starting with version "5.5", if "conflict_unload" and
   "auto_handling" configuration options are enabled, all matching
   loaded modules are unloaded.


Modules Variables
~~~~~~~~~~~~~~~~~

The following Modules-specific Tcl variables appeared on Modules 5.

+--------------+-------------------------------------------------------------------+
| Introduced   | New Modules-specific Tcl variables                                |
| in version   |                                                                   |
|==============|===================================================================|
| 5.1          | "ModuleVersion"                                                   |
+--------------+-------------------------------------------------------------------+


Modules configuration options
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

The following Modules configuration option has been introduced on
Modules 5.

+--------------+-------------------------------------------------------------------+
| Introduced   | New Modules configuration options                                 |
| in version   |                                                                   |
|==============|===================================================================|
| 5.0          | "quarantine_support"                                              |
+--------------+-------------------------------------------------------------------+
| 5.1          | "redirect_output", "mcookie_check", "collection_pin_tag"          |
+--------------+-------------------------------------------------------------------+
| 5.2          | "tcl_linter", "protected_envvars", "reset_target_state"           |
+--------------+-------------------------------------------------------------------+
| 5.3          | "ignore_cache", "cache_buffer_bytes", "cache_expiry_secs",        |
|              | "ignore_user_rc"                                                  |
+--------------+-------------------------------------------------------------------+
| 5.4          | "sticky_purge", "unique_name_loaded", "abort_on_error",           |
|              | "source_cache"                                                    |
+--------------+-------------------------------------------------------------------+
| 5.5          | "hide_auto_loaded", "logger", "logged_events", "conflict_unload"  |
+--------------+-------------------------------------------------------------------+

"auto_handling"

   Starting version 5.1, modules tagged "keep-loaded" are excluded
   from Useless Requirement Unload mechanism.

   Starting version 5.5:

   * Modules tagged "sticky" or "super-sticky" are excluded from
     Useless Requirement Unload mechanism.

   * No attempt to reload a Dependent Reload module is made if this
     module is not loadable (requirement not loaded or conflict found
     with loaded environment), even if force mode is enabled. Reload
     is attempted when module is not loadable if it is sticky (tagged
     super-sticky or sticky and force mode not enabled).

   * All reload of Dependent Reload modules are now performed on the
     top load, unload or switch evaluation rather right after the
     load, unload or switch that triggered the unload phase of the
     Dependent Reload mechanism.

   * Dependent Unload modules of Conflict Unload modules are merged
     into the Dependent Reload module list.

"avail_output", "avail_terse_output"

   Starting version 5.3, element "variant" is added to the list of
   accepted values.

   Starting version 5.3, element "variantifspec" is added to the list
   of accepted values. It is added to the default value list of both
   configuration options.

   Starting Modules 5.3, these configuration options accept value
   prefixed by "+" or "-" which means value should respectively be
   appended to or subtracted from current configuration option value.

   Starting version 5.3.1, element "indesym" is added to the list of
   accepted values.

"list_output", "list_terse_output"

   Starting Modules 5.3, these configuration options accept value
   prefixed by "+" or "-" which means value should respectively be
   appended to or subtracted from current configuration option value.

   Starting version 5.4, elements "alias" and "indesym" are added to
   the list of accepted values.

"colors", "protected_envvars", "shells_with_ksh_fpath", "tag_abbrev",
"tag_color_name", "variant_shortcut"

   Starting Modules 5.3, these configuration options accept value
   prefixed by "+" or "-" which means value should respectively be
   appended to or subtracted from current configuration option value.

"rcfile"

   Starting Modules 5.4, this configuration option accepts more than
   one global rc file location. A colon character separates each of
   these locations.

"pager"

   Starting Modules 5.5, pager is not launched if "modulecmd.tcl"
   program is run for scripting language.
